﻿namespace SMP.Common.Extensions
{
    public static partial class ObjectExtensions
    {
        public static T Copy<T>(this object obj) where T : class
        {
            if (obj == null) throw new ArgumentNullException("参数不能为null");
            T b = Activator.CreateInstance<T>();
            var properties = b.GetType().GetProperties().Where(p => p.PropertyType.IsPublic && p.CanWrite).ToList();
            var t = obj.GetType().GetProperties();
            foreach (var item in t)
            {
                var pro = properties.FirstOrDefault(x => x.Name == item.Name && x.PropertyType == item.PropertyType);
                if (pro != null)
                {
                    pro.SetValue(b, item.GetValue(obj, null), null);
                }
            }
            return b;
        }
    }
}
