﻿using Microsoft.AspNetCore.Mvc.Filters;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Core.Standard.Data.Infrastructure;

namespace SMP.Common.exception
{
    public class ApiActionFilterAttribute : Attribute, IActionFilter, IFilterMetadata
    {
        public void OnActionExecuted(ActionExecutedContext context)
        {
            IUnitOfWork service = context.HttpContext.RequestServices.GetService<IUnitOfWork>();
            if (service != null)
            {
                if (context.Exception == null)
                {
                    service.Commit();
                }
                else
                {
                    service.Rollback();
                }
            }
        }

        public void OnActionExecuting(ActionExecutingContext context)
        {
            IUnitOfWork service = context.HttpContext.RequestServices.GetService<IUnitOfWork>();
            if (service != null)
            { 
                if (context.HttpContext.User != null && context.HttpContext.User.Identity != null &&
                    context.HttpContext.User.Identity.IsAuthenticated && !string.IsNullOrEmpty(context.HttpContext.User.Identity.Name))
                {

                    service.CurrentName = context.HttpContext.User.Identity.Name;
                }
            }
        }
    }
}
