﻿using SMP.Model;
using SMP.Model.Compute;
using SMP.Model.Enums;
using System.Text;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;

namespace SMP.Data.Compute
{
    public interface ICompute_ExpenseItemRepository : IBaseRepository<Compute_ExpenseItem>
    {
        Task<IEnumerable<Compute_ExpenseItem>> GetExpenseItemByZoneMethodMode(ZoneMode Mode, List<int> ExpenseItemIds);
    }

    public class Compute_ExpenseItemRepository : BaseRepository<Compute_ExpenseItem>, ICompute_ExpenseItemRepository
    {
        public Compute_ExpenseItemRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }
        public async Task<IEnumerable<Compute_ExpenseItem>> GetExpenseItemByZoneMethodMode(ZoneMode Mode, List<int> ExpenseItemIds)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(" select a.* ");
            sb.Append(@" from Compute_ExpenseItem a 
left join Compute_ExpenseItemDetail b on b.ItemId = a.Id
left join Compute_Expense c on c.Id = b.ExpenseId and c.IsDelete = 0
left join Compute_ExpenseZone d on d.ExpenseId = c.Id and d.IsDelete = 0
left join Compute_ZoneMethod e on e.ZoneId = d.ZoneId ");
            sb.Append($" where e.Mode={(int)Mode} and a.Id in ({string.Join(',',ExpenseItemIds)}) ");
            return await _unitOfWork.QueryBySqlAsync<Compute_ExpenseItem>(sb.ToString());
        }
    }
}