﻿using SMP.Model;
using SMP.Model.Compute;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;

namespace SMP.Data.Compute
{
    public interface ICompute_ExpenseRepository : IBaseRepository<Compute_Expense>
    {
        Task<IEnumerable<View_ExpenseItemInfo>> GetServiceProviderExpenseInfo(int resolveSolutionId);
    }

    public class Compute_ExpenseRepository : BaseRepository<Compute_Expense>, ICompute_ExpenseRepository
    {
        public Compute_ExpenseRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public async Task<IEnumerable<View_ExpenseItemInfo>> GetServiceProviderExpenseInfo(int resolveSolutionId)
        {
            string sql = @"select ei.Name as ExpenseItemName,ei.Id as ExpenseItemId,e.id as ExpenseId,e.Name as ExpenseName from Compute_ExpenseItem ei 
inner join Compute_ExpenseItemDetail eid on ei.id=eid.ItemId
inner join Compute_Expense e on e.id=eid.ExpenseId
inner join Finance_ServiceBillResolveSolution s on s.ServiceProviderId=e.ServiceProviderId
where s.Id=@Id";
            var result =await _unitOfWork.Connection.QueryAsync<View_ExpenseItemInfo> (sql, new { Id = resolveSolutionId },transaction:_unitOfWork.Transaction);
            return result;
        }
    }
}