﻿using SMP.Model;
using SMP.Model.Compute;
using XYY.Common.Standard;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;
namespace SMP.Data.Compute
{
    public interface ICompute_ExpenseItemDetailRepository : IBaseRepository<Compute_ExpenseItemDetail>
    {
        Task<PageResult<View_ComputeExpreseItemDetail>> QueryComputeExpreseItemDetail(QueryModel queryModel);
    }

    public class Compute_ExpenseItemDetailRepository : BaseRepository<Compute_ExpenseItemDetail>, ICompute_ExpenseItemDetailRepository
    {
        public Compute_ExpenseItemDetailRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public async Task<PageResult<View_ComputeExpreseItemDetail>> QueryComputeExpreseItemDetail(QueryModel queryModel)
        {
            queryModel.QuerySort = new List<QuerySort>
            {
                new QuerySort
                {
                    Field="Id",
                    IsDesc=true
                },
                new QuerySort{Field= "Sort" },
                new QuerySort
                {
                    Field="DetailId",
                    IsDesc=true
                }
            };
            return await _unitOfWork.GetPagingListAsync<View_ComputeExpreseItemDetail>(queryModel);
        }
    }
}