﻿using SMP.Model.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;
using XYY.Core.Standard.Data.Infrastructure;

namespace SMP.Data.Finance
{
    public interface IFinance_OrderQuerySettingRepository : IBaseRepository<Finance_OrderQuerySetting>
    {
        Task<IEnumerable<Finance_OrderQuerySetting>> SearchSettingByName(string name);
    }
    public class Finance_OrderQuerySettingRepository : BaseRepository<Finance_OrderQuerySetting>, IFinance_OrderQuerySettingRepository
    {
        public Finance_OrderQuerySettingRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

      
        public Task<IEnumerable<Finance_OrderQuerySetting>> SearchSettingByName(string name)
        {
            string _name = $"%{name}%";
            string sql = "select * from Finance_OrderQuerySetting where Deleted=0 and Name like @Name";
            var result = _unitOfWork.Connection.QueryAsync<Finance_OrderQuerySetting>(sql, new { Name = _name },transaction:_unitOfWork.Transaction);
            return result;
        }
    }
}
