﻿using SMP.Model.Compute;
using SMP.Model.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;

namespace SMP.Data.Finance
{
    public interface IFinance_RecocileMappingRepository : IBaseRepository<Finance_RecocileMapping>
    {
        Task<IEnumerable<RecocileExpenseMapping>> GetAllExpenseMapping(int reconcileSolutionId);
    }

    public class Finance_RecocileMappingRepository : BaseRepository<Finance_RecocileMapping>, IFinance_RecocileMappingRepository
    {
        public Finance_RecocileMappingRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public  Task<IEnumerable<RecocileExpenseMapping>> GetAllExpenseMapping(int reconcileSolutionId)
        {
            string sql = @"select m.Id as MappingId, ReconcileSolutionId,BillDataName,ExpenseId,DataType,Sort,Name as ExpenseName 
                        from Finance_RecocileMapping m inner join Compute_Expense e on m.ExpenseId=e.Id
                        where m.ReconcileSolutionId=@ReconcileSolutionId";

            var result = base._unitOfWork.Connection.QueryAsync<RecocileExpenseMapping>(sql, new { ReconcileSolutionId = reconcileSolutionId });
            return result;
        }
    }

}
