﻿using SMP.Model.Compute;
using SMP.Model.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;

namespace SMP.Data.Finance
{
    public interface IFinance_ServiceBillExpenseMappingRepository : IBaseRepository<Finance_ServiceBillExpenseMapping>
    {
        Task<IEnumerable<ServiceBillExpenseMapping>> GetAllExpenseMapping(int reconcileSolutionId);
    }

    public class Finance_ServiceBillExpenseMappingRepository : BaseRepository<Finance_ServiceBillExpenseMapping>, IFinance_ServiceBillExpenseMappingRepository
    {
        public Finance_ServiceBillExpenseMappingRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public  Task<IEnumerable<ServiceBillExpenseMapping>> GetAllExpenseMapping(int mappingSolutionId)
        {
            string sql = @"select m.Id as MappingId,BillDataName,ExpenseId,Sort,Name as ExpenseName 
                        from Finance_ServiceBillExpenseMapping m inner join Compute_Expense e on m.ExpenseId=e.Id
                        where m.MappingSolutionId=@MappingSolutionId order by m.Sort desc";

            var result = base._unitOfWork.Connection.QueryAsync<ServiceBillExpenseMapping>(sql, new { MappingSolutionId = mappingSolutionId });
            return result;
        }
    }

}
