﻿using SMP.Model.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;

namespace SMP.Data.Finance
{
    public interface IFinance_ServiceBillExpenseMappingSolutionRepository : IBaseRepository<Finance_ServiceBillExpenseMappingSolution>
    {
        Task<IEnumerable<Finance_ServiceBillExpenseMappingSolution>> GetServiceBillMappings(string billName);
    }

    public class Finance_ServiceBillExpenseMappingSolutionRepository : BaseRepository<Finance_ServiceBillExpenseMappingSolution>, IFinance_ServiceBillExpenseMappingSolutionRepository
    {
        public Finance_ServiceBillExpenseMappingSolutionRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public  Task<IEnumerable<Finance_ServiceBillExpenseMappingSolution>> GetServiceBillMappings(string billName)
        {
            string sql = "SELECT s.* FROM Finance_ServiceBillResolveApply a inner join Finance_ServiceBillExpenseMappingSolution s on a.ServiceProviderId=s.ServiceProviderId and a.BillTypeCode=s.BillTypeCode where a.BillName=@BillName";
            var result = _unitOfWork.Connection.QueryAsync<Finance_ServiceBillExpenseMappingSolution>(sql, new { BillName = billName },transaction:_unitOfWork.Transaction);
            return result;
        }
    }
}
