﻿using SMP.Model.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;
using XYY.Common.Standard;
using SMP.Model.Dto.Finance;

namespace SMP.Data.Finance
{
    public interface IFinance_SpreadlogicDetailRepository : IBaseRepository<Finance_SpreadlogicDetail>
    {
        Task<long> CreateSpreadlogic(Finance_Spreadlogic model);
        Task<bool> UpdateSpreadlogic(Finance_Spreadlogic model);
        Task<PageResult<Finance_Spreadlogic>> QueryLogicPage(QueryModel queryModel);
        Task<IEnumerable<SpreadlogicDetailDto>> QueryLogicDetailForWeb(int SpreadlogicId = 0, int ExpenseItem = 0);
    }
    public class Finance_SpreadlogicDetailRepository : BaseRepository<Finance_SpreadlogicDetail>, IFinance_SpreadlogicDetailRepository
    {
        public Finance_SpreadlogicDetailRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }
        public async Task<PageResult<Finance_Spreadlogic>> QueryLogicPage(QueryModel queryModel)
        {
            return await _unitOfWork.GetPagingListAsync<Finance_Spreadlogic>(queryModel);
        }
        public async Task<long> CreateSpreadlogic(Finance_Spreadlogic model)
        {
            return await _unitOfWork.InsertAsync<Finance_Spreadlogic>(model);
        }
        public async Task<bool> UpdateSpreadlogic(Finance_Spreadlogic model)
        {
            return await _unitOfWork.UpdateAsync<Finance_Spreadlogic>(model);
        }
        public async Task<IEnumerable<SpreadlogicDetailDto>> QueryLogicDetailForWeb(int SpreadlogicId=0,int ExpenseItem=0)
        {
            StringBuilder sb = new StringBuilder();
            string field = string.Empty;string leftJoin = string.Empty;string where = " where 1=1 ";
            if (SpreadlogicId>0) { field = " ,d.SpreadlogicId,d.Id,d.ApportionMethod "; leftJoin = " left join Finance_SpreadlogicDetail d on d.ExpenseItemId=a.Id and d.ExpenseId=c.Id  "; where += " and d.SpreadlogicId="+SpreadlogicId; }
            sb.Append(@$" select a.Id ExpenseItemId,a.Name ExpenseName ,a1.ServiceName ServiceProviderName,a2.Name ExpenseCategoryName,c.Id ExpenseId,c.Name ExpenseName {field}
from Compute_ExpenseItem a");
            sb.Append($@" left join Sys_ServiceProvider a1 on a1.Id=a.ServiceProviderId
left join Compute_ExpenseItemCategory a2 on a2.Id=a.CategoryId
left join Compute_ExpenseItemDetail b on b.ItemId=a.Id
left join Compute_Expense c on c.Id=b.ExpenseId 
{leftJoin} ");
            if (ExpenseItem > 0) { where += " and a.Id="+ExpenseItem; }
            sb.Append(where);
            sb.Append(" order by a.Id ");
            return await _unitOfWork.QueryBySqlAsync<SpreadlogicDetailDto>(sb.ToString());
        }
    }
}
