﻿using SMP.Model.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;

namespace SMP.Data.Finance
{
    public interface ILogistics_ChannelRepository : IBaseRepository<Logistics_Channel>
    {
        Task<bool> BatchUpdateEntiy(List<Logistics_Channel> models);
    }

    public class Logistics_ChannelRepository : BaseRepository<Logistics_Channel>, ILogistics_ChannelRepository
    {
        public Logistics_ChannelRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }
        public async Task<bool> BatchUpdateEntiy(List<Logistics_Channel> models)
        {
            bool result = true;
            try
            {
                //比逐条更新稍微快点
                string sql = " update Logistics_Channel set PublicName=@PublicName,PublicCode=@PublicCode,IsEnable=@IsEnable where ThirdPartyUniqueId=@ThirdPartyUniqueId";
                await _unitOfWork.ExecuteAsync(sql, models);
            }
            catch (Exception ex)
            {
                result = false;
            }
            return result;


        }
    }
}
