﻿using SMP.Model.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Common.Standard;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;

namespace SMP.Data.Logistisc
{
    public interface ILogistisc_OrderRepository : IBaseRepository<Logistisc_Order>
    {
        Task<IEnumerable<Logistisc_Order>> GetAll(QueryModel queryModel);
        Task<IEnumerable<Logistisc_Order>> GetOrdersByLadingNumbers(IEnumerable<string> ladingBillNumbers);
    }

    public class Logistisc_OrderRepository : BaseRepository<Logistisc_Order>, ILogistisc_OrderRepository
    {
        public Logistisc_OrderRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public async Task<IEnumerable<Logistisc_Order>> GetAll(QueryModel queryModel)
        {
            string where = GetWhere(queryModel.QueryParamer);
            string sql = $"select * from Logistisc_Order where 1=1  {where}";
            var result =await  _unitOfWork.Connection.QueryAsync<Logistisc_Order>(sql);
            return result;
        }

        public async Task<IEnumerable<Logistisc_Order>> GetOrdersByLadingNumbers(IEnumerable<string> ladingBillNumbers)
        {
            string sql = $"select * from Logistisc_Order where LadingBillNumber in @LadingBillNumbers";

            var result =await _unitOfWork.Connection.QueryAsync<Logistisc_Order>(sql, new { LadingBillNumbers= ladingBillNumbers },transaction:_unitOfWork.Transaction);
            return result;
        }
    }
}
