﻿using SMP.Model.Report;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Common.Standard;
using XYY.Core.Standard.Data.Infrastructure;
using Dapper;

namespace SMP.Data.Report
{
    public interface IView_OrderExpenseItemCategoryAmountRepository : IViewRepository<View_OrderExpenseItemCategoryAmount>
    {
        IEnumerable<View_OrderExpenseItemCategoryAmount> QueryAll(QueryModel queryModel);
        Task<IEnumerable<View_OrderExpenseItemCategoryAmountSimple>> QueryAllEstimateAmountAsync(QueryModel queryModel);
    }

    public class View_OrderExpenseItemCategoryAmountRepository : ViewRepository<View_OrderExpenseItemCategoryAmount>, IView_OrderExpenseItemCategoryAmountRepository
    {
        public View_OrderExpenseItemCategoryAmountRepository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public IEnumerable<View_OrderExpenseItemCategoryAmount> QueryAll(QueryModel queryModel)
        {

            string sql = "SELECT * FROM View_OrderExpenseItemCategoryAmount WHERE 1=1 ";
            if (queryModel?.QueryParamer.Any() == true)
            {
                string where = GetWhere(queryModel.QueryParamer);
                sql += where;
            }
            else
            {
                IEnumerable<View_OrderExpenseItemCategoryAmount> emptyResult = new List<View_OrderExpenseItemCategoryAmount>();
                return emptyResult;
            }
            var result = _unitOfWork.Connection.Query<View_OrderExpenseItemCategoryAmount>(sql, transaction: _unitOfWork.Transaction, commandTimeout: 0);
            return result;

        }

        /// <summary>
        /// 查询订单的按费项的预估成本
        /// </summary>
        /// <param name="queryModel"></param>
        /// <returns></returns>
        public Task<IEnumerable<View_OrderExpenseItemCategoryAmountSimple>> QueryAllEstimateAmountAsync(QueryModel queryModel)
        {

            IEnumerable<View_OrderExpenseItemCategoryAmountSimple> emptyResult = new List<View_OrderExpenseItemCategoryAmountSimple>();
            string where = null;
            if (queryModel?.QueryParamer.Any() == true)
            {
                where = GetWhere(queryModel.QueryParamer);
                if (string.IsNullOrEmpty(where))
                    return Task.FromResult(emptyResult);



                string sql = $@"select o.SystemNo , c.id as ExpenseItemCategoryId,
sum(isnull(ea.SettlementAmount,0)) as SettlementAmount,
max(ev.VersionDate) as LastVersionDate,GETDATE() as CreateTime,'admin' as createUserName
from Logistisc_Order o 
inner join Compute_ExpenseAmount ea on o.systemno=ea.Number
inner join Compute_ExpenseItem ei on ea.ExpenseItemId=ei.Id
inner join Compute_ExpenseItemCategory c on c.Id=ei.CategoryId
left join Compute_ExpenseVersion ev on ea.ExpenseId=ev.ExpenseId and ea.VersionId=ev.Id
where ea.CostType=0 and ea.IsDelete=0  {where} 
group by o.SystemNo,c.id";

                var result = _unitOfWork.Connection.QueryAsync<View_OrderExpenseItemCategoryAmountSimple>(sql, transaction: _unitOfWork.Transaction, commandTimeout: 0);
                return result;
            }
            else
            {
                return Task.FromResult(emptyResult);
            }


        }
    }
}
