﻿using SMP.Model.Report;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Dapper;
using XYY.Core.Standard.Data.Infrastructure;

namespace SMP.Data.Report
{
    public interface IView_OrderExpenseItemTotalAmountV2Repository : IViewRepository<View_OrderExpenseItemTotalAmountV2>
    {
        Task<IEnumerable<View_OrderExpenseItemTotalAmountV2>> GetOrderAmount(IEnumerable<string> systemNos);
    }

    public class View_OrderExpenseItemTotalAmountV2Repository : ViewRepository<View_OrderExpenseItemTotalAmountV2>, IView_OrderExpenseItemTotalAmountV2Repository
    {
        public View_OrderExpenseItemTotalAmountV2Repository(IUnitOfWork unitOfWork) : base(unitOfWork)
        {

        }

        public async Task<IEnumerable<View_OrderExpenseItemTotalAmountV2>> GetOrderAmount(IEnumerable<string> systemNos)
        {
            int pageLen = 2000;
            int totalCount = systemNos.Count();
            int pageCount = (int)Math.Ceiling(totalCount / (decimal)pageLen);

            string sql = "select * from View_OrderExpenseItemTotalAmountV2 where SystemNo in @SystemNos";

            List<View_OrderExpenseItemTotalAmountV2> result = new List<View_OrderExpenseItemTotalAmountV2>();
            for (int p = 0; p < pageCount; p++)
            {
                var pageSystemNos = systemNos.Skip(pageLen * p).Take(pageLen);
                var pageResult = await _unitOfWork.Connection.QueryAsync<View_OrderExpenseItemTotalAmountV2>(sql, new { SystemNos=pageSystemNos });
                result.AddRange(pageResult);
            }
            return result;
        }
    }
}
