﻿using SMP.Model.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Common.Standard.Attributes;
using XYY.Core.Standard;

namespace SMP.Model.Compute
{
    public class Compute_Expense : BaseEntity
    {
        public string Name
        {
            get; set;
        }

        /// <summary>
        /// 类别Id
        /// </summary>
        public int ExpenseCategory
        {
            get; set;
        }

        /// <summary>
        /// 服务商Id
        /// </summary>
        public int ServiceProviderId
        {
            get; set;
        }

        /// <summary>
        /// 币种
        /// </summary>
        public int CurrenyId
        {
            get; set;
        }

        /// <summary>
        /// 计算方式
        /// </summary>
        public ComputeType ComputeType
        {
            get; set;
        }

        /// <summary>
        /// 最后版本日期
        /// </summary>
        public DateTime? LastVersionDate
        {
            get; set;
        }

        /// <summary>
        /// 最后版本Id
        /// </summary>
        public int? LastVersionId
        {
            get; set;
        }

        /// <summary>
        /// 最小计费量
        /// </summary>
        public decimal Min
        {
            get; set;
        }

        /// <summary>
        /// 步进值
        /// </summary>
        public decimal Stepping
        {
            get; set;
        }

        public bool IsDelete
        {
            get; set;
        }
        public ApportionMethodEnum ApportionMethod { get; set; }

        #region 扩展参数（接口）
        [NoDb]
        public List<Compute_ExpenseVersion>? Versions
        {
            get; set;
        }


        [NoDb]
        public int BindBillId
        {
            get; set;
        }

        [NoDb]
        public DateTime? VersionDate
        {
            get; set;
        }
        [NoDb]
        public int? VersionId
        {
            get; set;
        }

        [NoDb]
        public List<Compute_ExpenseDetail>? Details
        {
            get; set;
        }

        [NoDb]
        public List<Compute_Zone>? Zones
        {
            get; set;
        }
        #endregion
    }
}
