﻿using SMP.Model.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Model.Dto.Compute
{
    /// <summary>
    /// 计费结果
    /// </summary>
    public class ComputeAmountResult
    {

        /// <summary>
        /// 生效时间
        /// </summary>
        public DateTime ExpenseVersion
        {
            get; set;
        }

        public int DetailId
        {
            get; set;
        }

        public int VersionId
        {
            get; set;
        }

        /// <summary>
        /// 费用名称
        /// </summary>
        public string ExpenseName
        {
            get; set;
        }

        /// <summary>
        /// 业务单号
        /// </summary>
        public string BillNumber
        {
            get; set;
        }

        public bool IsSuccess
        {
            get; set;
        }

        public string Message
        {
            get; set;
        }

        /// <summary>
        /// CNY计费金额
        /// </summary>
        public decimal Amount
        {
            get; set;
        }

        /// <summary>
        /// CNY计费币种
        /// </summary>
        public string Currency
        {
            get; set;
        }
        /// <summary>
        /// 原币种
        /// </summary>
        public string BillCurrency { get; set; }
        /// <summary>
        /// 汇率
        /// </summary>
        public decimal SettlementRate { get; set; }
        /// <summary>
        /// 原币种计费金额
        /// </summary>
        public decimal AmountinOriginalCurrency { get; set; }
        public int ExpenseId { get; set; }
        public int ExpenseItemId { get; set; }

        /// <summary>
        /// 相关分区
        /// </summary>
        public string Zones
        {
            get; set;
        }
        public ApportionMethodEnum ApportionMethod { get; set; }
    }

    /// <summary>
    /// 计费来源
    /// </summary>
    public class ComputeAmountSouce
    {
        public DateTime ComputeDate
        {
            get; set;
        }

        public int BindBillId
        {
            get; set;
        }

        /// <summary>
        /// 克重
        /// </summary>
        public decimal Weight
        {
            get; set;
        }

        /// <summary>
        /// 立方厘米
        /// </summary>
        public decimal Volume
        {
            get; set;
        }

        /// <summary>
        /// 立方米
        /// </summary>
        public decimal M3
        {
            get; set;
        }

        /// <summary>
        /// 帐单币种 （入参）
        /// </summary>
        public string? Currency { get; set; }
        /// <summary>
        /// 计算传入值
        /// </summary>
        public decimal ComputeValue
        {
            get; set;
        }

        /// <summary>
        /// 费项Id
        /// </summary>
        public int ExpenseItemId
        {
            get; set;
        }

        /// <summary>
        /// 业务单号
        /// </summary>
        public string? BillNumber
        {
            get; set;
        }

        /// <summary>
        /// 国家
        /// </summary>
        public string CountryCode
        {
            get; set;
        }

        /// <summary>
        /// 省州
        /// </summary>
        public string? State
        {
            get; set;
        }

        /// <summary>
        /// 城市
        /// </summary>
        public string? City
        {
            get; set;
        }

        /// <summary>
        /// 邮编
        /// </summary>
        public string? ZipCode
        {
            get; set;
        }

        /// <summary>
        /// 地址
        /// </summary>
        public string? Stree
        {
            get; set;
        }

        /// <summary>
        /// 提单口岸
        /// </summary>
        public string? Port
        {
            get; set;
        }

        /// <summary>
        /// 运单号
        /// </summary>
        public string? TrackingNumber
        {
            get; set;
        }

        /// <summary>
        /// 票数
        /// </summary>
        public int OrderQty
        {
            get; set;
        }

        /// <summary>
        /// 物品申报价值
        /// </summary>
        public decimal GoodsDeclareValue
        {
            get; set;
        }
        public string? IOSS { get; set; }
    }
}
