﻿using SMP.Model.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Model.Dto.Finance
{
    public class QueryExpenseByLadingInput
    {
        public int ExpenseId { get; set; }
        public int ExpenseItemId { get; set; }
        public int VersionId { get; set; }
        public int BindBillId { get; set; }
        public string? LadingBillNumber { get; set; }
        public decimal Weight { get; set; }
        public WeightUnit WeightType { get; set; }
        public DateTime? BillTime { get; set; }

    }
    public class QueryExpenseByLadingResult
    {
        public int ExpenseId { get; set; }
        public int ExpenseItemId { get; set; }
        public string ExpenseName { get; set; }
        public int VersionId { get; set; }
        public int BindBillId { get; set; }
        public DateTime VersionDate { get; set; }
        public decimal IncidentalFee
        {
            get; set;
        }
        public string? IncidentalCurrency { get; set; }
        public decimal Weight { get; set; }
        public WeightUnit WeightUnit { get; set; }
        public string? WeightUnitStr { get { return WeightUnit.GetName(); } }
        public WeightType WeightType { get; set; }
        public string? WeightTypeStr { get { return WeightType.GetName(); } }
        public int ExpenseDetailId { get; set; }
        /// <summary>
        /// 去重识别 1为不重复
        /// </summary>
        public int num { get; set; }
        public ApportionMethodEnum ApportionMethod { get; set; }
        //目的口岸
        public string? Port { get; set; }

    }
}
