﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Core.Standard;

namespace SMP.Model.Finance
{
    public class Finance_CostDetail : BaseEntity
    {
        public string SystemNo { get; set; }
        /// <summary>
        /// 费项
        /// </summary>
        public int? IncidentalType { get; set; }
        /// <summary>
        /// 收入、支出
        /// </summary>
        public string IncomeOrESxpense { get; set; }
        /// <summary>
        /// 成本
        /// </summary>
        public string OrderCost { get; set; }
        /// <summary>
        /// 价格版本
        /// </summary>
        public string? PriceVersion { get; set; }
        /// <summary>
        /// 帐单类型
        /// </summary>
        public string? BillTypeName { get; set; }
        /// <summary>
        /// 帐单类型唯一码
        /// </summary>
        public string BillTypeCode { get; set; }
        /// <summary>
        /// 交易号
        /// </summary>
        public string TransactionNo { get; set; }
        /// <summary>
        /// 费用名称
        /// </summary>
        public string? ChargeName { get; set; }
        /// <summary>
        /// 币种
        /// </summary>
        public string Currency
        {
            get; set;
        }

        /// <summary>
        /// 金额
        /// </summary>
        public double AmountinOriginalCurrency
        {
            get; set;
        }

        /// <summary>
        /// 结算币种
        /// </summary>
        public string SettlementCurrency
        {
            get; set;
        }

        /// <summary>
        /// 结算汇率
        /// </summary>
        public double SettlementRate
        {
            get; set;
        }


        /// <summary>
        /// 结算金额
        /// </summary>
        public double SettlementAmount
        {
            get; set;
        }

        /// <summary>
        /// 费用说明
        /// </summary>
        public string FeeDescription
        {
            get; set;
        }
        /// <summary>
        /// 冲减帐目
        /// </summary>
        public bool Offset
        {
            get; set;
        }
        /// <summary>
        /// 客户
        /// </summary>
        public int CustomerId { get; set; }
        /// <summary>
        /// 计费单号
        /// </summary>
        public string AccountingNo
        {
            get; set;
        }

    }
}
