﻿using SMP.Model.Compute;
using SMP.Model.Enums;
using XYY.Common.Standard.Attributes;
using XYY.Core.Standard;

namespace SMP.Model.Finance
{
    public class Finance_Logistics_LadingBill : BaseEntity
    {
        public Finance_Logistics_LadingBill() {
            finances = new List<Finance_Incidental>();
            canFeeTypes = new List<Compute_ExpenseItem>();
        }
        public string LadingBillNumber { get; set; }
        public int? BoxQty { get; set; }
        public int? Pieces { get; set; }
        public string? BillTypeCode { get; set; }
        public string? Departure { get; set; }
        public string? _Destination { get; set; }
        public decimal Weight { get; set; }
        public decimal? ChargeWeight { get; set; }
        public decimal? ServicesWeight { get; set; }
        public int? ServiceProviderId { get; set; }
        public string? BillCurrency { get; set; }
        public DateTime BillTime { get; set; }
        public string? BillFileUrl { get; set; }
        public bool IsDelete { get; set; }
        public decimal Cost { get; set; }
        public decimal Prepaid { get; set; }
        public int BillState { get; set; }
        public int? SpreadlogicId { get; set; }
        /// <summary>
        /// 立方米
        /// </summary>
        public decimal? M3
        {
            get; set;
        }
        public SystemBillTypeEnum SystemBillType { get; set; }
        public int OrderQuerySettingId { get; set; }
        public CompanyPossessEnum CompanyPossess { get; set; }
        public int? TemplateId { get; set; }

        /// <summary>
        /// 主要给前端用的字段
        /// </summary>
        [NoDb]
        public List<Finance_Incidental> finances { get; set; }
        [NoDb]
        public List<Compute_ExpenseItem> canFeeTypes { get; set; }
    }
}
