﻿using SMP.Data.Compute;
using SMP.Model.Compute;
using XYY.Common.Standard;

namespace SMP.Service.Compute
{
    public interface IComputeExpenseCategoryService
    {
        Task<PageResult<Compute_ExpenseCategory>> QueryExpenseCategory(QueryModel queryModel);
        Task UpdateComputeExpenseCategory(Compute_ExpenseCategory ExpenseCategory);
        Task InsertComputeExpenseCategory(Compute_ExpenseCategory ExpenseCategory);
        Task DeleteComputeExpenseCategory(Compute_ExpenseCategory ExpenseCategory);
        Task<IEnumerable<Compute_ExpenseCategory>> GetAllComputeExpenseCategory();
    }

    public class ComputeExpenseCategoryService : IComputeExpenseCategoryService
    {
        private ICompute_ExpenseCategoryRepository categoryRepository;

        public ComputeExpenseCategoryService(ICompute_ExpenseCategoryRepository categoryRepository)
        {
            this.categoryRepository = categoryRepository;
        }

        public async Task DeleteComputeExpenseCategory(Compute_ExpenseCategory ExpenseCategory)
        {
            await this.categoryRepository.DeleteAsync(ExpenseCategory);
        }

        public async Task<IEnumerable<Compute_ExpenseCategory>> GetAllComputeExpenseCategory()
        {
            return await this.categoryRepository.QueryAsync();
        }

        public async Task InsertComputeExpenseCategory(Compute_ExpenseCategory ExpenseCategory)
        {
            await this.categoryRepository.InsertAsync(ExpenseCategory);
        }

        public async Task<PageResult<Compute_ExpenseCategory>> QueryExpenseCategory(QueryModel queryModel)
        {
            if (queryModel.QueryParamer != null
                && queryModel.QueryParamer.Count > 0
                )
            {
                var serach = queryModel.QueryParamer.FirstOrDefault(x => x.Filed == "search");
                if (serach != null)
                {
                    queryModel.QueryParamer.Remove(serach);
                    string sql = $@"select * from Compute_ExpenseCategory(nolock) where Name Like '%{serach.Value}%' or Description ='%{serach.Value}%'";
                    return await categoryRepository.QueryPagerAsync(queryModel, sql);
                }
                else
                    return await categoryRepository.QueryPagerAsync(queryModel);
            }
            else
            {
                return await categoryRepository.QueryPagerAsync(queryModel);
            } 
        }

        public async Task UpdateComputeExpenseCategory(Compute_ExpenseCategory ExpenseCategory)
        {
            await this.categoryRepository.UpdateAsync(ExpenseCategory);
        }
    }
}
