﻿using SMP.Data.Compute;
using SMP.Model.Compute;
using XYY.Common.Standard;

namespace SMP.Service.Compute
{
    public interface IComputeExpenseItemCategoryService
    {
        Task<PageResult<Compute_ExpenseItemCategory>> QueryExpenseItemCategory(QueryModel queryModel);
        Task UpdateComputeExpenseItemCategory(Compute_ExpenseItemCategory ExpenseItemCategory);
        Task InsertComputeExpenseItemCategory(Compute_ExpenseItemCategory ExpenseItemCategory);
        Task DeleteComputeExpenseItemCategory(Compute_ExpenseItemCategory ExpenseItemCategory);
        Task<IEnumerable<Compute_ExpenseItemCategory>> GetAllExpenseItemCategory();
    }

    public class ComputeExpenseItemCategoryService : IComputeExpenseItemCategoryService
    {
        private ICompute_ExpenseItemCategoryRepository categoryRepository;

        public ComputeExpenseItemCategoryService(ICompute_ExpenseItemCategoryRepository categoryRepository)
        {
            this.categoryRepository = categoryRepository;
        }

        public async Task DeleteComputeExpenseItemCategory(Compute_ExpenseItemCategory ExpenseItemCategory)
        {
            await this.categoryRepository.DeleteAsync(ExpenseItemCategory);
        }

        public async Task<IEnumerable<Compute_ExpenseItemCategory>> GetAllExpenseItemCategory()
        {
            return await this.categoryRepository.QueryAsync();
        }

        public async Task InsertComputeExpenseItemCategory(Compute_ExpenseItemCategory ExpenseItemCategory)
        {
            await this.categoryRepository.InsertAsync(ExpenseItemCategory);
        }

        public async Task<PageResult<Compute_ExpenseItemCategory>> QueryExpenseItemCategory(QueryModel queryModel)
        {
            if (queryModel.QueryParamer != null
              && queryModel.QueryParamer.Count > 0
              )
            {
                var serach = queryModel.QueryParamer.FirstOrDefault(x => x.Filed == "search");
                if (serach != null)
                {
                    queryModel.QueryParamer.Remove(serach);
                    string sql = $@"select * from Compute_ExpenseItemCategory(nolock) where Name Like '%{serach.Value}%' or Description ='%{serach.Value}%' ";
                    return await categoryRepository.QueryPagerAsync(queryModel, sql);
                }
                else
                    return await categoryRepository.QueryPagerAsync(queryModel);
            }
            else
            {
                return await categoryRepository.QueryPagerAsync(queryModel); 
            }
        }

        public async Task UpdateComputeExpenseItemCategory(Compute_ExpenseItemCategory ExpenseItemCategory)
        {
            await this.categoryRepository.UpdateAsync(ExpenseItemCategory);
        }
    }
}
