﻿using SMP.Data;
using SMP.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Common.Standard;

namespace SMP.Service
{
    public interface ISysCountryService
    {
        Task<PageResult<Sys_Country>> QueryCountry(QueryModel queryModel);
        Task UpdateSysCountry(Sys_Country Country);
        Task InsertSysCountry(Sys_Country Country);
        Task DeleteSysCountry(Sys_Country Country);

        
        Task<IEnumerable<Sys_Country>> GetSysCountry();
    }

    public class SysConutryService : ISysCountryService
    {
        ISys_CountryRepository _countryRepository;

        public SysConutryService(ISys_CountryRepository countryRepository)
        {
            _countryRepository = countryRepository;
        }

        public async Task DeleteSysCountry(Sys_Country Country)
        {
            await _countryRepository.DeleteAsync(Country);
        }

        public async Task InsertSysCountry(Sys_Country Country)
        {
            await _countryRepository.InsertAsync(Country);
        }

        public async Task<PageResult<Sys_Country>> QueryCountry(QueryModel queryModel)
        {
            if (queryModel.QueryParamer != null
               && queryModel.QueryParamer.Count > 0
               )
            {
                var serach = queryModel.QueryParamer.FirstOrDefault(x => x.Filed == "search");
                if (serach != null)
                {
                    queryModel.QueryParamer.Remove(serach);
                    string sql = $@"select * from Sys_Country(nolock) where CnName like '%{serach.Value}%' or EnName like '%{serach.Value}%' or Code='{serach.Value}'";
                    return await _countryRepository.QueryPagerAsync(queryModel, sql);
                }
                else
                    return await _countryRepository.QueryPagerAsync(queryModel);
            }
            else
                return await _countryRepository.QueryPagerAsync(queryModel);
        }

        public async Task UpdateSysCountry(Sys_Country Country)
        {
            await _countryRepository.UpdateAsync(Country);
        }
        public async Task<IEnumerable<Sys_Country>> GetSysCountry()
        {
            return await _countryRepository.QueryAsync();
        }
    }
}
