﻿using SMP.Data;
using SMP.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Common.Standard;

namespace SMP.Service
{
    public interface IServiceProviderService
    {
        Task<PageResult<Sys_ServiceProvider>> QueryProviderService(QueryModel queryModel);
        Task UpdateProvider(Sys_ServiceProvider ServiceProvider);
        Task InsertProvider(Sys_ServiceProvider ServiceProvider);
        Task DeleteProvider(Sys_ServiceProvider ServiceProvider);
        Task<IEnumerable<Sys_ServiceProvider>> GetProviderList();
        Task<IEnumerable<Sys_ServiceProvider>> GetProviderByids(IEnumerable<int> ids);
    }

    public class ServiceProviderService : IServiceProviderService
    {
        ISys_ServiceProviderRepository _serviceProviderRepository;

        public ServiceProviderService(ISys_ServiceProviderRepository serviceProviderRepository)
        {
            _serviceProviderRepository = serviceProviderRepository;
        }

        public async Task DeleteProvider(Sys_ServiceProvider ServiceProvider)
        {
            await _serviceProviderRepository.DeleteAsync(ServiceProvider);
        }

        public async Task InsertProvider(Sys_ServiceProvider ServiceProvider)
        {
            await _serviceProviderRepository.InsertAsync(ServiceProvider);
        }

        public async Task<PageResult<Sys_ServiceProvider>> QueryProviderService(QueryModel queryModel)
        {
            if (queryModel.QueryParamer != null
               && queryModel.QueryParamer.Count > 0
               )
            {
                var serach = queryModel.QueryParamer.FirstOrDefault(x => x.Filed == "search");
                if (serach != null)
                {
                    queryModel.QueryParamer.Remove(serach);
                    string sql = $@"select * from Sys_ServiceProvider(nolock) where ServiceName like '%{serach.Value}%' or Contacts like '%{serach.Value}%' or Telephone like '%{serach.Value}%'";
                    return await _serviceProviderRepository.QueryPagerAsync(queryModel, sql);
                }
                else
                    return await _serviceProviderRepository.QueryPagerAsync(queryModel);
            }
            else
                return await _serviceProviderRepository.QueryPagerAsync(queryModel);
        }

        public async Task UpdateProvider(Sys_ServiceProvider ServiceProvider)
        {
            await _serviceProviderRepository.UpdateAsync(ServiceProvider);
        }
        public async Task<IEnumerable<Sys_ServiceProvider>> GetProviderList()
        {
            return await _serviceProviderRepository.QueryAsync();
        }

        public async Task<IEnumerable<Sys_ServiceProvider>> GetProviderByids(IEnumerable<int> ids)
        {
            return await _serviceProviderRepository.QueryAsync(i=>i.Id.In(ids));
        }
    }
}

