﻿using SMP.Model.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Service.OrderRangeQuery.Dto
{
    public class OrderRangeQuerySettingDto
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public List<int>? PublicChannelIds { get; set; }
        public string? PublicChannelNames { get; set; }
        public List<int>? DeliveryChannelIds { get; set; }
        public string? DeliveryChannelNames { get; set; }

        public List<int>? CustomerIds { get; set; }
        public List<int>? NotCustomerIds { get; set; }
        public string? CustomerNames { get; set; }

        public TimeNode? TimeNode { get; set; }
        public string TimeNodeName { get { return TimeNode == null ? string.Empty : TimeNode.GetDescription(); } }
        public NumberType? NumberType { get; set; }
        public string NumberTypeName { get { return NumberType == null ? string.Empty : NumberType.GetDescription(); } }

        public string? Numbers { get; set; }
        public List<DateTime>? TimeRange { get; set; }
        public string TimeFrom { get { return TimeRange != null && TimeRange.Count > 0 ? TimeRange[0].ToString("yyyy-MM-dd") : string.Empty; } }
        public string TimeTo { get { return TimeRange != null && TimeRange.Count > 1 ? TimeRange[1].ToString("yyyy-MM-dd") : string.Empty; } }

        public bool? IsExecuted { get; set; }
        public string? IsExecutedName { get { return IsExecuted == null || IsExecuted == false ? "否" : "是"; } }

        public OrderRangeQueryStatus Status { get; set; }
        public string StatusName { get { return Status.GetDescription(); } }
        public string? Message { get; set; }
        public int? TotalCount { get; set; }
    }
}
