﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Service.Report.Dto
{
    public class OrderCostProfitDto
    {
        public string SystemNo { get; set; }
        public string TrackingNumber { get; set; }
        public string LadingBillNumber { get; set; }
        public int PublicChannelId { get; set; }
        public string PublicChannelName { get; set; }
        public string DeliveryChannelId { get; set; }
        public string DeliveryChannelName { get; set; }
        public int CustomerId { get; set; }
        public decimal OpWeight { get; set; }
        public decimal OpWeightKg { get { return OpWeight / 1000.0m; } }
        public string? CustomerName { get; set; }
        public decimal? CustomerAmount { get; set; }
        public string? BranchCompanyName { get; set; }
        public decimal? BranchCompanyAmount { get; set; }
        public List<OrderExpenseItemAmount> ExpenseItemAmounts { get; set; }

        public decimal EstimateTotalCost { get; set; }
        public decimal? BillTotalCost { get; set; }
        public decimal? BranchCompanyProfit { get; set; }
        public decimal HeadCompanyEstimateProfit { get { return ((CustomerAmount ?? 0) - EstimateTotalCost); } }
        public decimal? HeadCompanyBillProfit { get { return CustomerAmount != null && BillTotalCost != null ? CustomerAmount - BillTotalCost : null; } }

    }
}
