﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XYY.Common.Standard;

namespace SMP.Service.Report
{
    public static class ReportQueryParamPreHandle
    {
        public static void PreHandleQueryModel(ref QueryModel queryModel)
        {
            if (queryModel.QueryParamer?.Any() == true)
            {
                var numberTypeP = queryModel.QueryParamer.FirstOrDefault(i => i.Filed == "NumberType");
                var numberFieldP = queryModel.QueryParamer.FirstOrDefault(i => i.Filed == "Number");
                if (numberTypeP != null)
                {
                    queryModel.QueryParamer.Remove(numberTypeP);
                    if (numberFieldP != null)
                    {
                        string numberTypeName = "SystemNo";
                        if (numberTypeP.Value == "0" || numberTypeP.Value == "1")
                            numberTypeName = "SystemNo";
                        if (numberTypeP.Value == "2")
                            numberTypeName = "TransferNumber";
                        if (numberTypeP.Value == "3")
                            numberTypeName = "TrackingNumber";
                        if (numberTypeP.Value == "4")
                            numberTypeName = "BoxNumber";
                        if (numberTypeP.Value == "5")
                            numberTypeName = "LadingBillNumber";

                        numberFieldP.Filed = numberTypeName;
                    }
                }
                else
                {
                    if (numberFieldP != null)
                        queryModel.QueryParamer.Remove(numberFieldP);
                }

                var timeNodeP = queryModel.QueryParamer.FirstOrDefault(i => i.Filed == "TimeNode");
                var timeFromP = queryModel.QueryParamer.FirstOrDefault(i => i.Filed == "From");
                var timeToP = queryModel.QueryParamer.FirstOrDefault(i => i.Filed == "To");

                if (timeNodeP != null)
                {
                    queryModel.QueryParamer.Remove(timeNodeP);
                }
                if (timeFromP != null)
                {
                    queryModel.QueryParamer.Remove(timeFromP);
                }
                if (timeToP != null)
                {
                    queryModel.QueryParamer.Remove(timeToP);
                }

                if (timeNodeP != null && timeFromP != null && timeToP != null)
                {
                    string timeNodeVal = timeNodeP.Value;
                    string timeNodeField = "OrderTime";
                    if (timeNodeVal == "1")
                        timeNodeField = "ReceiveTime";
                    else if (timeNodeVal == "2")
                        timeNodeField = "PackingTime";
                    else if (timeNodeVal == "3")
                        timeNodeField = "SendOutTime";

                    var timeFrom = timeFromP.Value;
                    var timeTo = timeToP.Value;

                    DateTime.TryParse(timeFrom, out DateTime f);
                    DateTime.TryParse(timeTo, out DateTime t);

                    QueryParamer newTimeFrom = new QueryParamer { Filed = timeNodeField, Method = "GrE", Value = timeFrom };
                    QueryParamer newTimeTo = new QueryParamer { Filed = timeNodeField, Method = "LeE", Value = timeTo };
                    queryModel.QueryParamer.Add(newTimeFrom);
                    queryModel.QueryParamer.Add(newTimeTo);
                }
            }
        }
    }
}
