﻿using SMP.Model.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Service.ServiceBillResolve.Dto
{
    public class ServiceBillResolveSolutionDto
    {
        public int Id { get; set; }
       
        public string Name { get; set; }
        public string BillTypeCode { get; set; }
        public int ServiceProviderId { get; set; }
        public string? Description { get; set; }
  
        public string? CreateUserName { get; set; }
        public DateTime? CreateTime { get; set; }

        public string? ServiceProviderName { get; set; }

        public string? BillTypeName { get; set; }
        public string? WeightDataName { get; set; }
        public bool Enabled { get; set; }

        public List<ServiceBillResolveSolutionRuleDto> Rules { get; set; }
    }

    public class ServiceBillResolveSolutionRuleDto
    {
        public int Id { get; set; }
        public string RuleName { get; set; }
        public int SolutionId { get; set; }
        public string SheetPattern { get; set; }
        public string? DataName { get; set; }
        public bool DataUseRegx { get; internal set; }
        public string? DataAddressPattern { get; set; }

        public string? NumberAddressPattern { get; set; }
        public string? NumberResolveRegx { get; set; }


        public string? FeeNameAddressPattern { get; set; }

        public string? Currency { get; set; }

        public string? ListingTypeName { get { return ListingType.GetDescription(); } }
        public BillListingStyle ListingType { get; set; }
        public string? NumberTypeName { get { return NumberType.GetDescription(); } }
        public NumberType NumberType { get; set; }

        public bool SetBillTimeOnResolve { get; set; }
        public string? BillTimeAddressPattern { get; set; }


    }


}
