﻿using SMP.Model.Enums;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Service.ServiceBillResolve
{
    public class ServiceBillResolverFactory
    {
        public static IServiceBillResover GetBillResover(BillListingStyle ruleType)
        {
            if (ruleType == BillListingStyle.FeeList)
            {
                IServiceBillResover feeListResolver = new FeeListModeResolver();

                return feeListResolver;
            }
            else
            {
                IServiceBillResover numberListResolver = new NumberListModeResolver();
                return numberListResolver;
            }
        }
    }
}
