﻿using RestSharp;
using SMP.Service.ThirdPartyRequest.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Service.ThirdPartyRequest
{
    public interface IBranchCompanyService
    {
        Task<RestResponse<IEnumerable<BranchCompanyOrderAmount>>> GetBranchCompanyOrderAmount(IEnumerable<string> systemNos);
    }
    public class BranchCompanyService: IBranchCompanyService
    {
        private static readonly string _wmsUrl = "http://wms.xingyunyi.cn/";
        //private static readonly string _wmsUrl = "http://192.168.1.31/";


        public Task<RestResponse<IEnumerable<BranchCompanyOrderAmount>>> GetBranchCompanyOrderAmount(IEnumerable<string> systemNos)
        {
            var client = new RestClient(_wmsUrl);
            var request = new RestRequest("/api/BranchCompanyFinance/OrderBranchCompanyAmount");
            request.AddJsonBody(systemNos);
            request.AddHeader("token", "29301AD4500BB72059677F1EF6198CFD");
            Task<RestResponse<IEnumerable<BranchCompanyOrderAmount>>> result = client.ExecutePostAsync<IEnumerable<BranchCompanyOrderAmount>>(request);
            return result;
        }
    }
}
