﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Service.BaseInfo;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.BaseInfo
{
    [ApiController]
    [Route("[controller]/[action]")]
    public class BaseInfoController : ApiControllerBase
    {
        IBaseInfoService _baseInfoService;
        public BaseInfoController(IBaseInfoService baseInfoService)
        {
            _baseInfoService = baseInfoService;
        }


        [HttpGet]
        public async Task<ApiJsonModel> GetAllCustomers()
        {
            var customers = await _baseInfoService.GetAllCustomers();
            return ApiJsonModel.OK(customers);
        }

        [HttpGet]
        public async Task<ApiJsonModel> GetAllPublicChannels()
        {
            var channels = await _baseInfoService.GetAllPublicChannels();
            return ApiJsonModel.OK(channels);
        }

        [HttpGet]
        public async Task<ApiJsonModel> GetAllDeliveryChannels()
        {
            var channels = await _baseInfoService.GetAllDeliveryChannels();
            return ApiJsonModel.OK(channels);
        }
    }
}
