﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Common.Enum;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using XYY.Core.Standard.Mvc;
using EnumItem = SMP.Common.Enum.EnumItem;

namespace SMP.Api.Base.Controllers.BaseInfo
{
    [AllowAnonymous]
    [ApiController]
    public class EnumsController : ApiControllerBase
    {
        [Route("/enums")]
        [HttpPost]
        public IEnumerable<EnumItem> Enums(GetEnumParam param)
        {
            if (string.IsNullOrWhiteSpace(param.Name))
                return null;

            string assembly = "SMP.Model";
            string enumTypeName = $"SMP.Model.Enums.{param.Name}";

            var models = EnumHelper.GetEnumModels(assembly, enumTypeName);
            if (param.AddDefault && models?.Any() == true)
            {
                var result = models.ToList();
                if (!param.Required)
                    result.Insert(0, new EnumItem { Desc = "不限", Name = "不限", Value = null });
                return result;
            }
            else return models?.OrderBy(x=>x.Name)?.ThenBy(x=>x.Desc);
        }
    }

    public class GetEnumParam
    {
        public string Name { get; set; }
        public bool AddDefault { get; set; }

        public bool Required { get; set; }
    }
}
