﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model.Dto.Compute;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Compute
{
    [ApiController]
    [Route("[controller]")]
    public class ComputeController : ControllerBase
    {
        private IComputeAmountService amountService;

        public ComputeController(IComputeAmountService amountService)
        {
            this.amountService = amountService;
        }

        [HttpPost]
        public async Task<ApiJsonModel<List<ComputeAmountResult>>> Post([FromBody] List<ComputeAmountSouce> souces)
        {
            var result = (await amountService.MultipleCompute(souces)).ToList();
            return ApiJsonModel<List<ComputeAmountResult>>.OK(result);
        }
    }
}
