﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Formula
{
    [ApiController]
    [Route("[controller]")]
    public class ComputeExpenseController : ControllerBase
    {
        public IComputeExpenseService ComputeExpenseService { get; }

        public ComputeExpenseController(IComputeExpenseService ComputeExpenseService)
        {
            this.ComputeExpenseService = ComputeExpenseService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Compute_Expense Formula)
        {
            await ComputeExpenseService.InsertComputeExpense(Formula);
            return ApiJsonModel.OK();
        }

        [HttpGet]
        public async Task<ApiJsonModel<Compute_Expense>> Get(int id)
        {
            var m = await ComputeExpenseService.GetBase(id);
            return ApiJsonModel<Compute_Expense>.OK(m);
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Compute_Expense expense)
        {
            await ComputeExpenseService.UpdateComputeExpense(expense); ;
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Compute_Expense Formula)
        {

            await ComputeExpenseService.DeleteComputeExpense(Formula);
            return ApiJsonModel.OK();
        }


    }
}
