﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using SMP.Service.Dtos;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.ComputeExpense
{
    [ApiController]
    [Route("[controller]")]
    public class ComputeExpenseVersionController : ControllerBase
    {
        public IComputeExpenseService ComputeExpenseService { get; }

        public ComputeExpenseVersionController(IComputeExpenseService computeExpenseService)
        {
            ComputeExpenseService = computeExpenseService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Compute_Expense Expense)
        {
            await ComputeExpenseService.AddComputeVersionExpense(Expense);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Compute_Expense Expense)
        {
            await ComputeExpenseService.UpdateComputeVersionExpense(Expense);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] IdParam IdParam)
        {
            await ComputeExpenseService.DeleteComputeExpenseVersion(IdParam.Id);
            return ApiJsonModel.OK();
        }

        [HttpGet]
        public async Task<ApiJsonModel<Compute_Expense>> Get([FromQuery] int VersionId)
        {
            var model = await ComputeExpenseService.GetVersion(VersionId);
            return ApiJsonModel<Compute_Expense>.OK(model);
        }
    }
}
