﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model.Compute;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.ComputeExpenseItemTemplate
{
    [ApiController]
    [Route("[controller]")]
    public class ComputeExpenseItemTemplateController : ControllerBase
    {
        public IComputeExpenseItemTemplateService CountryService { get; }

        public ComputeExpenseItemTemplateController(IComputeExpenseItemTemplateService countryService)
        {
            CountryService = countryService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Compute_ExpenseItemTemplate expenseItemTemplate)
        {
            await CountryService.InsertExpenseItemTemplate(expenseItemTemplate);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Compute_ExpenseItemTemplate expenseItemTemplate)
        {
            await CountryService.UpdateExpenseItemTemplate(expenseItemTemplate);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Compute_ExpenseItemTemplate expenseItemTemplate)
        {
            await CountryService.DeleteExpenseItemTemplate(expenseItemTemplate);
            return ApiJsonModel.OK();
        }
        [HttpGet]
        public async Task<ApiJsonModel> Get([FromQuery] int Id)
        {
            var d = await CountryService.Get(Id);
            return ApiJsonModel.OK(d);
        }
    }
}
