﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Common.Standard;

namespace SMP.Api.Base.Controllers
{ 
    [ApiController]
    [Route("[controller]")]
    public class QueryComputeExpenseItemTemplateController : ControllerBase
    {
        public QueryComputeExpenseItemTemplateController(IComputeExpenseItemTemplateService expenseItemTemplateService)
        {
            _expenseItemTemplateService = expenseItemTemplateService;
        }

        public IComputeExpenseItemTemplateService _expenseItemTemplateService { get; }

        [HttpPost]
        public async Task<PageResult<Compute_ExpenseItemTemplate>> Post([FromBody] QueryModel model)
        {
            return await _expenseItemTemplateService.QueryComputeExpenseItemTemplate(model);
        }

        [HttpGet]
        public async Task<IEnumerable<Compute_ExpenseItemTemplate>> Get()
        {
            var result= await _expenseItemTemplateService.GetComputeExpenseItemTemplate();
            return result?.OrderBy(x => x.Name);
        }
    }
}
