﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Formula
{
    [ApiController]
    [Route("[controller]")]
    public class ComputeFormulaController : ControllerBase
    {
        public IComputeFormulaService computeFormulaService { get; }

        public ComputeFormulaController(IComputeFormulaService computeFormulaService)
        {
            this.computeFormulaService = computeFormulaService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Compute_Formula Formula)
        {
            await computeFormulaService.InsertComputeFormula(Formula);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Compute_Formula Formula)
        {
            await computeFormulaService.UpdateComputeFormula(Formula);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Compute_Formula Formula)
        {
            
            await computeFormulaService.DeleteComputeFormula(Formula);
            return ApiJsonModel.OK();
        }


    }
}
