﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model.Compute;
using SMP.Service.Compute;
using XYY.Common.Standard;

namespace SMP.Api.Base.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class QueryComputeFormulaController : ControllerBase
    {
        public QueryComputeFormulaController(IComputeFormulaService computeFormulaService)
        {
            ComputeFormulaService = computeFormulaService;
        }

        public IComputeFormulaService ComputeFormulaService { get; }
        [HttpGet]
        public async Task<List<Compute_Formula>> Get()
        {
            return await ComputeFormulaService.GetAll();
        }

        [HttpPost]
        public async Task<PageResult<Compute_Formula>> Post([FromBody] QueryModel model)
        {
            return await ComputeFormulaService.QueryComputeFormula(model);
        }
    }
}
