﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Zone
{
    [ApiController]
    [Route("[controller]")]
    public class ComputeZoneController : ControllerBase
    {
        public IComputeZoneService computeZoneService { get; }

        public ComputeZoneController(IComputeZoneService computeZoneService)
        {
            this.computeZoneService = computeZoneService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Compute_Zone Zone)
        {
            await computeZoneService.InsertComputeZone(Zone);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Compute_Zone Zone)
        {
            await computeZoneService.UpdateComputeZone(Zone);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Compute_Zone Zone)
        {

            await computeZoneService.DeleteComputeZone(Zone);
            return ApiJsonModel.OK();
        }

        [HttpGet]
        public async Task<ApiJsonModel<Compute_Zone>> Get([FromQuery] int Id)
        {
            var detail = await computeZoneService.GetDetails(Id);
            return ApiJsonModel<Compute_Zone>.OK(detail);
        }

    }
}
