﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Common.Standard;

namespace SMP.Api.Base.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class QueryComputeZoneController : ControllerBase
    {
        public QueryComputeZoneController(IComputeZoneService computeZoneService)
        {
            ComputeZoneService = computeZoneService;
        }

        public IComputeZoneService ComputeZoneService { get; }

        [HttpPost]
        public async Task<PageResult<Compute_Zone>> Post([FromBody] QueryModel model)
        {
            return await ComputeZoneService.QueryComputeZone(model);
        }

        [HttpGet]
        public async Task<IEnumerable<Compute_Zone>> Get()
        {
            return await ComputeZoneService.QueryComputeZone();
        }
    }
}
