﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Service;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Country
{  
    [ApiController]
    [Route("[controller]")]
    public class CountryController : ControllerBase
    {
        public ISysCountryService CountryService { get; }

        public CountryController(ISysCountryService countryService)
        {
            CountryService = countryService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Sys_Country Country)
        {
            await CountryService.InsertSysCountry(Country);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Sys_Country Country)
        {
            await CountryService.UpdateSysCountry(Country);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Sys_Country Country)
        {
            await CountryService.DeleteSysCountry(Country);
            return ApiJsonModel.OK();
        }


    }
}
