﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Service;
using XYY.Common.Standard;

namespace SMP.Api.Base.Controllers
{ 
    [ApiController]
    [Route("[controller]")]
    public class QueryCountryController : ControllerBase
    {
        public QueryCountryController(ISysCountryService countryService)
        {
            CountryService = countryService;
        }

        public ISysCountryService CountryService { get; }

        [HttpPost]
        public async Task<PageResult<Sys_Country>> Post([FromBody] QueryModel model)
        {
            return await CountryService.QueryCountry(model);
        }

        [HttpGet]
        public async Task<IEnumerable<Sys_Country>> Get()
        {
            return await CountryService.GetSysCountry();
        }
    }
}
