﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Service;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Curreny
{
    [ApiController]
    [Route("[controller]")]
    public class CurrenyController : ControllerBase
    {
        public ISysCurrencyService CurrenyService { get; }

        public CurrenyController(ISysCurrencyService currenyService)
        {
            CurrenyService = currenyService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Sys_Currency currency)
        {
            await CurrenyService.InsertSysCurrency(currency);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Sys_Currency currency)
        {
            await CurrenyService.UpdateSysCurrency(currency);
            return ApiJsonModel.OK();
        }
         

    }
}
