﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Service;
using XYY.Common.Standard;

namespace SMP.Api.Base.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class QueryCurrenyController : ControllerBase
    {
        public QueryCurrenyController(ISysCurrencyService currenyService)
        {
            CurrenyService = currenyService;
        }

        public ISysCurrencyService CurrenyService { get; }

        [HttpPost]
        public async Task<PageResult<Sys_Currency>> Post([FromBody] QueryModel model)
        {
            return await CurrenyService.QueryCurrency(model);
        }
        [HttpGet]
        public async Task<IEnumerable<Sys_Currency>> Get()
        {
            return await CurrenyService.GetSysCurrencyList();
        }
    }
}
