﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.ExpenseCategory
{
    [ApiController]
    [Route("[controller]")]
    public class ExpenseCategoryController : ControllerBase
    {
        public IComputeExpenseCategoryService ExpenseCategoryService { get; }

        public ExpenseCategoryController(IComputeExpenseCategoryService ExpenseCategoryService)
        {
            this.ExpenseCategoryService = ExpenseCategoryService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Compute_ExpenseCategory ExpenseCategory)
        {
            await ExpenseCategoryService.InsertComputeExpenseCategory(ExpenseCategory);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Compute_ExpenseCategory ExpenseCategory)
        {
            await ExpenseCategoryService.UpdateComputeExpenseCategory(ExpenseCategory);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Compute_ExpenseCategory ExpenseCategory)
        {
            await ExpenseCategoryService.DeleteComputeExpenseCategory(ExpenseCategory);
            return ApiJsonModel.OK();
        }


    }
}
