﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Common.Standard;

namespace SMP.Api.Base.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class QueryExpenseCategoryController : ControllerBase
    {
        public QueryExpenseCategoryController(IComputeExpenseCategoryService ExpenseCategoryService)
        {
            this.ExpenseCategoryService = ExpenseCategoryService;
        }

        public IComputeExpenseCategoryService ExpenseCategoryService { get; }

        [HttpPost]
        public async Task<PageResult<Compute_ExpenseCategory>> Post([FromBody] QueryModel model)
        {
            return await ExpenseCategoryService.QueryExpenseCategory(model);
        }

        [HttpGet]
        public async Task<IEnumerable<Compute_ExpenseCategory>> Get()
        {
            return await ExpenseCategoryService.GetAllComputeExpenseCategory();
        }
    }
}
