﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Formula
{
    [ApiController]
    [Route("[controller]")]
    public class ExpenseItemController : ControllerBase
    {
        public IComputeExpenseItemService ComputeExpenseItemService { get; }

        public ExpenseItemController(IComputeExpenseItemService ComputeExpenseService)
        {
            this.ComputeExpenseItemService = ComputeExpenseService;
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] View_ComputeExpreseItemDetail detail)
        {
            await ComputeExpenseItemService.SaveItemDetail(detail);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] View_ComputeExpreseItemDetail detail)
        { 
            await ComputeExpenseItemService.DeleteComputeExpenseItem(detail);
            return ApiJsonModel.OK();
        }


    }
}
