﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Formula
{
    [ApiController]
    [Route("[controller]")]
    public class ExpenseItemDetailController : ControllerBase
    {
        public IComputeExpenseItemService ComputeExpenseItemService { get; }

        public ExpenseItemDetailController(IComputeExpenseItemService ComputeExpenseService)
        {
            this.ComputeExpenseItemService = ComputeExpenseService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] View_ComputeExpreseItemDetail detail)
        {
            await ComputeExpenseItemService.SaveItemDetail(detail);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] View_ComputeExpreseItemDetail detail)
        {
            await ComputeExpenseItemService.SaveItemDetail(detail);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] View_ComputeExpreseItemDetail detail)
        {
            
            await ComputeExpenseItemService.DeleteComputeExpenseItemDetail(detail);
            return ApiJsonModel.OK();
        }


    }
}
