﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Model.Compute;
using SMP.Service;
using SMP.Service.Compute;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.ExpenseItemCategory
{
    [ApiController]
    [Route("[controller]")]
    public class ExpenseItemCategoryController : ControllerBase
    {
        public IComputeExpenseItemCategoryService ExpenseItemCategoryService { get; }

        public ExpenseItemCategoryController(IComputeExpenseItemCategoryService ExpenseItemCategoryService)
        {
            this.ExpenseItemCategoryService = ExpenseItemCategoryService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Compute_ExpenseItemCategory ExpenseItemCategory)
        {
            await ExpenseItemCategoryService.InsertComputeExpenseItemCategory(ExpenseItemCategory);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Compute_ExpenseItemCategory ExpenseItemCategory)
        {
            await ExpenseItemCategoryService.UpdateComputeExpenseItemCategory(ExpenseItemCategory);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Compute_ExpenseItemCategory ExpenseItemCategory)
        {
            await ExpenseItemCategoryService.DeleteComputeExpenseItemCategory(ExpenseItemCategory);
            return ApiJsonModel.OK();
        }


    }
}
