﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Model.Finance;
using SMP.Service.Finance;
using XYY.Common.Standard;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Finance
{
    [AllowAnonymous]
    [ApiController]
    [Route("[controller]/[action]")]
    public class BillSetController : ControllerBase
    {
        private readonly ILogistisc_BillTypeService _BillTypeService;
        public BillSetController(ILogistisc_BillTypeService  BillTypeService)
        {
            this._BillTypeService = BillTypeService;
        }

        [HttpPost]
        public async Task<ApiJsonModel<PageResult<Logistisc_BillType>>> Query(QueryModel queryModel)
        {
            var result = await _BillTypeService.QueryPage(queryModel);
            return ApiJsonModel<PageResult<Logistisc_BillType>>.OK(result);
        }
        [HttpPost]
        public async Task<ApiJsonModel<IEnumerable<Logistisc_BillType>>> GetList()
        {
            var result = await _BillTypeService.QueryAll();
            return ApiJsonModel<IEnumerable<Logistisc_BillType>>.OK(result);
        }
        [HttpPost]
        public async Task<ApiJsonModel> Create(Logistisc_BillType model)
        {
            await _BillTypeService.Create(model);
            return ApiJsonModel.OK();
        }
        [HttpPost]
        public async Task<ApiJsonModel> Modify(Logistisc_BillType model)
        {
            await _BillTypeService.Edit(model);
            return ApiJsonModel.OK();
        }
        [HttpPost]
        public async Task<ApiJsonModel<bool>> Remove(int id)
        {
            var ok = await _BillTypeService.Delete(id);
            return ApiJsonModel<bool>.OK(ok);
        }
    }
}
