﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model.Finance;
using SMP.Service.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using XYY.Common.Standard;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Finance
{
    [ApiController]
    [Route("[controller]/[action]")]
    public class ChannelController : ControllerBase
    {
        private readonly ILogistics_ChannelService  _ChannelService;
        public ChannelController(ILogistics_ChannelService ChannelService)
        {
            this._ChannelService = ChannelService;
        }
        [HttpGet]
        public async Task<ApiJsonModel> BatchCreate()
        {
            await _ChannelService.SyncChannel();
            return ApiJsonModel.OK();
        }
        [HttpPost]
        public async Task<ApiJsonModel> Modify(Logistics_Channel entity)
        {
            await _ChannelService.Edit(entity);
            return ApiJsonModel.OK();
        }
        [HttpPost]
        public async Task<ApiJsonModel<PageResult<Logistics_Channel>>> Query(QueryModel queryModel)
        {
            var result = await _ChannelService.QueryPage(queryModel);
            return ApiJsonModel<PageResult<Logistics_Channel>>.OK(result);
        }

    }
}
