﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model.Compute;
using SMP.Model.Dto.DataInterconnection;
using SMP.Model.Dto.Finance;
using SMP.Service.Finance;
using SMP.Service.ThirdPartyRequest;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using XYY.Common.Standard;
using XYY.Core.Standard.Data.Infrastructure;
using XYY.Core.Standard.Mvc;
using Dapper;
using SMP.Model.Finance;

namespace SMP.Api.Base.Controllers.Finance
{
    [ApiController]
    [Route("[controller]/[action]")]
    public class OrderCostController : ControllerBase
    {
        private readonly IOrderCostService _orderCostService;
        private readonly IWMSDataInterconnectionService _wMSDataInterconnection;
        private readonly IUnitOfWork _unitOfWork;

        public OrderCostController(IOrderCostService orderCostService, IWMSDataInterconnectionService wMSDataInterconnection, IUnitOfWork unitOfWork)
        {
            this._orderCostService =orderCostService;
            this._wMSDataInterconnection = wMSDataInterconnection;
            _unitOfWork = unitOfWork;
        }
        [HttpPost]
        public async Task<ApiJsonModel<PageResult<Compute_ExpenseAmount>>> Query(QueryModel queryModel)
        {
            var result = await _orderCostService.QueryPage(queryModel);
            return ApiJsonModel<PageResult<Compute_ExpenseAmount>>.OK(result);
        }
        [HttpGet]
        public async Task<ApiJsonModel<bool>> synctest(string ladingBill)
        {
            ThirdPartyData_Input input = new ThirdPartyData_Input() { LadingBillNumber = ladingBill };
            var ThirdPartyLadingBillDto = await _wMSDataInterconnection.PullOrderInfo(input);
            var result = await _orderCostService.SyncOrderInfo(ThirdPartyLadingBillDto.orders);
            return ApiJsonModel<bool>.OK(result);
        }

        //[HttpPost]
        //public async Task<ApiJsonModel<bool>> EestimateOrderEndCost(List<string> systemNo)
        //{
        //    var orders = await _unitOfWork.Connection.QueryAsync<Logistisc_Order>("select * from Logistisc_Order where systemNo in @SystemNo", new { SystemNo = systemNo });
        //    var ok = await _orderCostService.EestimateOrderEndCost(orders);
        //    return ApiJsonModel<bool>.OK(ok);
        //}
    }
}
