﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model.Dto.Finance;
using SMP.Model.Finance;
using SMP.Service.Finance;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using XYY.Common.Standard;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Finance
{
    [ApiController]
    [Route("[controller]/[action]")]
    public class SpreadlogicController : ControllerBase
    {
        private readonly ISpreadlogicService _spreadlogicService;
        public SpreadlogicController(ISpreadlogicService spreadlogicService)
        {
            this._spreadlogicService = spreadlogicService;
        }
        [HttpPost]
        public async Task<ApiJsonModel<PageResult<Finance_Spreadlogic>>> QueryLogicPage(QueryModel queryModel)
        {
            var result = await _spreadlogicService.QueryLogicPage(queryModel);
            return ApiJsonModel<PageResult<Finance_Spreadlogic>>.OK(result);
        }
        [HttpPost]
        public async Task<ApiJsonModel> Create(Finance_Spreadlogic model)
        {
            await _spreadlogicService.Create(model);
            return ApiJsonModel.OK();
        }
        [HttpPost]
        public async Task<ApiJsonModel> Modify(Finance_Spreadlogic model)
        {
            await _spreadlogicService.Modify(model);
            return ApiJsonModel.OK();
        }
        
       [HttpGet]
        public async Task<ApiJsonModel<IEnumerable<SpreadlogicDetailDto>>> QueryLogicDetailForWeb(int SpreadlogicId = 0, int ExpenseItem = 0)
        {
            var result = await _spreadlogicService.QueryLogicDetailForWeb(SpreadlogicId, ExpenseItem);
            return ApiJsonModel<IEnumerable<SpreadlogicDetailDto>>.OK(result);
        }
        [HttpGet]
        public async Task<ApiJsonModel> Remove(int Id)
        {
            await _spreadlogicService.Remove(Id);
            return ApiJsonModel.OK();
        }
        [HttpGet]
        public async Task<ApiJsonModel<IEnumerable<Finance_Spreadlogic>>> GetLogicList()
        {
            var result= await _spreadlogicService.GetLogicList();
            return ApiJsonModel<IEnumerable<Finance_Spreadlogic>>.OK(result);
        }
    }
}
