﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Service;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Curreny
{
    [ApiController]
    [Route("[controller]")]
    public class RateController : ControllerBase
    {
        public ISysRateService RateService { get; }

        public RateController(ISysRateService rateService)
        {
            RateService = rateService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Sys_Rate Rate)
        {
            await RateService.InsertSysRate(Rate);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Sys_Rate Rate)
        {
            await RateService.UpdateSysRate(Rate);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Sys_Rate Rate)
        {
            await RateService.DeleteSysRate(Rate);
            return ApiJsonModel.OK();
        }


    }
}
