﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Service.Dtos;
using SMP.Service.Reconcile;
using SMP.Service.Reconcile.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using XYY.Common.Standard;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Reconcile
{
    [AllowAnonymous]
    [ApiController]
    [Route("[controller]/[action]")]
    public class ReconcileController : ControllerBase
    {
        IReconcileService _reconcileService;


        //AliYunPostFileSerivce

        public ReconcileController(IReconcileService serviceBillResolveService)
        {
            _reconcileService = serviceBillResolveService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> RefreshReconcileData(RefreshReconcileDataParam param)
        {
            await _reconcileService.RefreshReconcileData(param);
            return ApiJsonModel.OK();
        }




        [HttpPost]
        public async Task<ApiJsonModel> Reconcile(QueryModel queryModel)
        {
            ReconcileDisplayResult solutions = await _reconcileService.Reconcile(queryModel);
            return ApiJsonModel.OK(solutions);
        }
    }
}
