﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Service.Report;
using SMP.Service.Report.Dto;
using XYY.Common.Standard;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Report
{
    [AllowAnonymous]
    [ApiController]
    [Route("[controller]/[action]")]
    public class ReportController : ControllerBase
    {

        IGeneralCostReportV2Service _generalCostReportV2Service;
        ICostProfitReportService _costProfitReportService;
        public ReportController(IGeneralCostReportV2Service generalCostReportV2Service, ICostProfitReportService costProfitReportService)
        {
            _generalCostReportV2Service = generalCostReportV2Service;
            _costProfitReportService = costProfitReportService; 
        }


        [HttpPost]
        public async Task<ApiJsonModel> QueryGeneralCostReportPage(QueryModel param)
        {
            var pageResult = await _generalCostReportV2Service.QueryGeneralCostReport(param);
            return ApiJsonModel.OK(pageResult);
        }

        //[HttpPost]
        //public async Task<FileContentResult> DownGeneralCostReport(QueryModel param)
        //{
        //    byte[] content = await _generalCostReportService.DownGeneralCostReport(param);
        //    return File(content, "application/vnd.ms-excel");
        //}

        [HttpPost]
        public async Task<ApiJsonModel> LoadCostDetail(LoadCostDetailParam param)
        {
            CostBatchDto dto = await _generalCostReportV2Service.LoadCostDetail(param);
            return ApiJsonModel.OK(dto);
        }

        //[HttpPost]
        //public async Task<ApiJsonModel> QueryCostProfitReportPage(QueryModel param)
        //{
        //    var pageResult = await _costProfitReportService.QueryCostProfitReportPage(param);
        //    return ApiJsonModel.OK(pageResult);
        //}


        //[HttpPost]
        //public async Task<FileContentResult> DownCostProfitReport(QueryModel param)
        //{
        //    byte[] content = await _costProfitReportService.DownCostProfitReportV2(param);
            
        //    return File(content, "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
        //}

        [HttpPost]
        public async Task<FileContentResult> DownCostProfitReport(QueryModel param)
        {
            byte[] content = await _costProfitReportService.DownCostProfitReportV3(param);

            return File(content, "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
        }

    }
}
