﻿using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using SMP.Service.Finance;
using SMP.Service.Finance.Dto;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.ServiceBill
{
    [AllowAnonymous]
    [ApiController]
    [Route("[controller]/[action]")]
    public class ServiceBillSpreadController : ControllerBase
    {
        IServiceBillSpreadService _serviceBillSpreadService;

        public ServiceBillSpreadController(IServiceBillSpreadService serviceBillSpreadService)
        {
            _serviceBillSpreadService = serviceBillSpreadService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> SpreadServiceBill(SpreadServiceBillParam param)
        {
            if (param == null)
                throw new Exception("参数无效");

            await _serviceBillSpreadService.SpreadServiceBill(param);
            return ApiJsonModel.OK();
        }

        [HttpGet]
        public async Task<ApiJsonModel> IsServiceBillRangeSpread(string billName)
        {
            if (string.IsNullOrWhiteSpace(billName))
                throw new Exception("参数无效");

            bool orderRangeSpread = await _serviceBillSpreadService.IsServiceBillOrderRangeSpread(billName);
            string result = orderRangeSpread.ToString();
            return ApiJsonModel.OK(result);
        }
    }
}
