﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Service;
using XYY.Common.Standard;

namespace SMP.Api.Base.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class QueryProviderServiceController : ControllerBase
    {
        public QueryProviderServiceController(IServiceProviderService serviceProviderService)
        {
            ServiceProviderService = serviceProviderService;
        }

        public IServiceProviderService ServiceProviderService { get; }

        [HttpPost]
        public async Task<PageResult<Sys_ServiceProvider>> Post([FromBody] QueryModel model)
        {
            return await ServiceProviderService.QueryProviderService(model);
        }
        [HttpGet]
        public async Task<IEnumerable<Sys_ServiceProvider>> Get()
        {
            return await ServiceProviderService.GetProviderList();
        }


    }
}
