﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Service;
using XYY.Core.Standard.Mvc;

namespace SMP.Api.Base.Controllers.Curreny
{
    [ApiController]
    [Route("[controller]")]
    public class ServiceProviderController : ControllerBase
    {
        public IServiceProviderService ServiceProviderService { get; }

        public ServiceProviderController(IServiceProviderService serviceProviderService)
        {
            ServiceProviderService = serviceProviderService;
        }

        [HttpPost]
        public async Task<ApiJsonModel> Post([FromBody] Sys_ServiceProvider ServiceProvider)
        {
            await ServiceProviderService.InsertProvider(ServiceProvider);
            return ApiJsonModel.OK();
        }

        [HttpPut]
        public async Task<ApiJsonModel> Put([FromBody] Sys_ServiceProvider ServiceProvider)
        {
            await ServiceProviderService.UpdateProvider(ServiceProvider);
            return ApiJsonModel.OK();
        }

        [HttpDelete]
        public async Task<ApiJsonModel> Delete([FromBody] Sys_ServiceProvider ServiceProvider)
        {
            await ServiceProviderService.DeleteProvider(ServiceProvider);
            return ApiJsonModel.OK();
        }


    }
}
