﻿using Microsoft.AspNetCore.Mvc;
using SMP.Model;
using SMP.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace SMP.Api.Base.Controllers.ServiceProvider
{
    [ApiController]
    [Route("[controller]/[action]")]
    public class ServiceProviderController : ControllerBase
    {
        public ServiceProviderController(IServiceProviderService serviceProviderService)
        {
            ServiceProviderService = serviceProviderService;
        }

        public IServiceProviderService ServiceProviderService { get; }

        [HttpGet]
        public async Task<IEnumerable<Sys_ServiceProvider>> AllProviders()
        {
            return await ServiceProviderService.GetProviderList();
        }
    }
}
