﻿using System.Net;

namespace SMP.Api.Remote
{
    public class ApiJsonModel<T>
    {
        /// <summary>
        /// 错误码(0表示无错误)
        /// </summary>
        public HttpStatusCode code { get; set; }
        /// <summary>
        /// 是否成功
        /// </summary>
        public bool success { get; set; }
        /// <summary>
        /// 错误信息
        /// </summary>
        public string error { get; set; }
        /// <summary>
        /// 消息
        /// </summary>
        public string message { get; set; }
        /// <summary>
        /// Json数据
        /// </summary>
        public T data { get; set; }

        public string Guid
        {
            get; set;
        }

        public static ApiJsonModel<T> OK(T data)
        {
            return new ApiJsonModel<T>
            {
                code = HttpStatusCode.OK,
                data = data,
                success = true,
                message = "成功"
            };
        }

        public static ApiJsonModel<T> Error(string message, T data)
        {
            return new ApiJsonModel<T>
            {
                code = HttpStatusCode.InternalServerError,
                data = data,
                success = false,
                message = message
            };
        }
    }

}
