﻿using RestSharp;

namespace SMP.Api.Remote
{
    public class DHLApi : IBaseRemoteApi
    {
        public string Name => "DHL";
        public class DHLCheckRequest
        {
            /// <summary>
            /// 
            /// </summary>
            public int menu2Id { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string toCountryName { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string toCountryCode { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string toCity { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string toZipCode { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public string expressType { get; set; }
        }

        public class DHLCHeckResult
        {
            public int Code
            {
                get; set;
            }

            public string Message
            {
                get; set;
            }

            public DHLCheckResultData data
            {
                get; set;
            }
        }

        public class DHLCheckResultData
        {
            /// <summary>
            /// 返回值
            /// </summary>
            public string result
            {
                get; set;
            }

            /// <summary>
            /// 下单地址
            /// </summary>
            public string url
            {
                get; set;
            }

            /// <summary>
            /// 是否发送
            /// </summary>
            public int isSend
            {
                get; set;
            }
        }


        public async Task<bool> IsRemote(Req req)
        {
            DHLCheckRequest requestData = new DHLCheckRequest
            {
                menu2Id = 22,
                toCountryName = "A",
                toCountryCode = req.ReceiveCountryCode,
                toCity = req.ReceiveCity,
                toZipCode = req.ReceiveZipCode,
                expressType = "WPX"
            };
            var client = new RestClient("https://www.5idhl.com/api/dhl/mailing/remoteAreaQuery");
            var request = new RestRequest();
            request.AddJsonBody(requestData);
            var response = await client.PostAsync<DHLCHeckResult>(request);

            if (response.Code == 200)
            {
                if (response.data.result == "查询结果：您的快件可以正常派件，但是会产生偏远地区派件费用，请点击查阅详情")
                {
                    return true;
                }
                else if (response.data.result == "查询结果：您所在的区域目前可以取派件。")
                {
                    return false;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                if (response.Message.Contains("城市无效"))
                    return false;
                else if (response.Message.Contains("邮编无效"))
                    return false;
                else
                    return false;
            }

        }
    }
}
