using Microsoft.AspNetCore.Mvc;

namespace SMP.Api.Remote.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class RemoteServiceController : ControllerBase
    {
        private IEnumerable<IBaseRemoteApi> apis;

        public RemoteServiceController(IEnumerable<IBaseRemoteApi> apis)
        {
            this.apis = apis;
        }

        [HttpGet(Name = "GetApis")]
        public ApiJsonModel<IEnumerable<string>> Get()
        {
            return ApiJsonModel<IEnumerable<string>>.OK(apis.Select(x => x.Name));
        }

        [HttpPost]
        public async Task<ApiJsonModel<bool>> IsRemote(Req req)
        {
            var api = apis.FirstOrDefault(x => x.Name == req.ApiName);
            if (api == null)
                throw new Exception($"{req.ApiName}");
            return ApiJsonModel<bool>.OK(await api.IsRemote(req));
        }
    }
}