﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SMP.Tool.TimingTask.Models
{
    public class Finance_TimeTask : BaseEntity
    {
        /// <summary>
        /// 任务状态
        /// 0：待读取
        /// </summary>
        public FinanceEnum TaskStatus { get; set; }
        public DateTime StartTime { get; set; }
        public DateTime EndTime { get; set; }
        public int RetryTotal { get; set; }
        public int RetryCount { get; set; }
        public int OrderCount { get; set; }
        public int LadingBillCount { get; set; }
        public bool? IsSucceed { get; set; }
        public string? ResultMessage { get; set; }
    }
    public enum FinanceEnum
    {
        [Description("待读取")]
        WaitRead = 0,
        [Description("待执行")]
        WaitExecute = 10,
        [Description("执行中")]
        Executing = 20,
        [Description("执行完成")]
        Succeed = 30,
        [Description("执行完成")]
        Fail = 40,
    }
}
